//
// HPB_bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// bot_weapons.h
//

#ifndef BOT_WEAPONS_H
#define BOT_WEAPONS_H

// weapon ID values for Valve's Half-Life Deathmatch
#define VALVE_WEAPON_CROWBAR       1
#define VALVE_WEAPON_GLOCK         2
#define VALVE_WEAPON_PYTHON        3
#define VALVE_WEAPON_MP5           4
#define VALVE_WEAPON_CHAINGUN      5
#define VALVE_WEAPON_CROSSBOW      6
#define VALVE_WEAPON_SHOTGUN       7
#define VALVE_WEAPON_RPG           8
#define VALVE_WEAPON_GAUSS         9
#define VALVE_WEAPON_EGON         10
#define VALVE_WEAPON_HORNETGUN    11
#define VALVE_WEAPON_HANDGRENADE  12
#define VALVE_WEAPON_TRIPMINE     13
#define VALVE_WEAPON_SATCHEL      14
#define VALVE_WEAPON_SNARK        15

#define VALVE_MAX_NORMAL_BATTERY   100
#define VALVE_HORNET_MAX_CARRY      8


// weapon ID values for Valve's Team Fortress Classic & 1.5
#define TF_WEAPON_UNKNOWN1       1
#define TF_WEAPON_UNKNOWN2       2
#define TF_WEAPON_MEDIKIT        3
#define TF_WEAPON_SPANNER        4
#define TF_WEAPON_AXE            5
#define TF_WEAPON_SNIPERRIFLE    6
#define TF_WEAPON_AUTORIFLE      7
#define TF_WEAPON_SHOTGUN        8
#define TF_WEAPON_GL            12
#define TF_WEAPON_FLAMETHROWER  13
#define TF_WEAPON_RPG           14
#define TF_WEAPON_IC            15
#define TF_WEAPON_UNKNOWN16     16
#define TF_WEAPON_AC            17
#define TF_WEAPON_UNKNOWN18     18
#define TF_WEAPON_UNKNOWN19     19
#define TF_WEAPON_TRANQ         20
#define TF_WEAPON_RAILGUN       21
#define TF_WEAPON_PL            22
#define TF_WEAPON_SUPERSHOTGUN   9
#define TF_WEAPON_NAILGUN       10
#define TF_WEAPON_SUPERNAILGUN  11
#define TF_WEAPON_KNIFE         23


// weapon ID values for Counter-Strike
#define CS_WEAPON_P228           1
#define CS_WEAPON_UNKNOWN1       2
#define CS_WEAPON_SCOUT          3
#define CS_WEAPON_HEGRENADE      4
#define CS_WEAPON_XM1014         5
#define CS_WEAPON_C4             6
#define CS_WEAPON_MAC10          7
#define CS_WEAPON_AUG            8
#define CS_WEAPON_SMOKEGRENADE   9
#define CS_WEAPON_ELITE         10
#define CS_WEAPON_UNKNOWN3      11
#define CS_WEAPON_UNKNOWN4      12
#define CS_WEAPON_UNKNOWN5      13
#define CS_WEAPON_UNKNOWN6      14
#define CS_WEAPON_UNKNOWN7      15
#define CS_WEAPON_USP           16
#define CS_WEAPON_GLOCK18       17
#define CS_WEAPON_AWP           18
#define CS_WEAPON_MP5NAVY       19
#define CS_WEAPON_M249          20
#define CS_WEAPON_M3            21
#define CS_WEAPON_M4A1          22
#define CS_WEAPON_TMP           23
#define CS_WEAPON_G3SG1         24
#define CS_WEAPON_FLASHBANG     25
#define CS_WEAPON_DEAGLE        26
#define CS_WEAPON_SG552         27
#define CS_WEAPON_AK47          28
#define CS_WEAPON_KNIFE         29
#define CS_WEAPON_P90           30


// weapon ID values for Gearbox's OpFor Deathmatch
#define GEARBOX_WEAPON_CROWBAR       1
#define GEARBOX_WEAPON_GLOCK         2
#define GEARBOX_WEAPON_PYTHON        3
#define GEARBOX_WEAPON_MP5           4
#define GEARBOX_WEAPON_CHAINGUN      5
#define GEARBOX_WEAPON_CROSSBOW      6
#define GEARBOX_WEAPON_SHOTGUN       7
#define GEARBOX_WEAPON_RPG           8
#define GEARBOX_WEAPON_GAUSS         9
#define GEARBOX_WEAPON_EGON         10
#define GEARBOX_WEAPON_HORNETGUN    11
#define GEARBOX_WEAPON_HANDGRENADE  12
#define GEARBOX_WEAPON_TRIPMINE     13
#define GEARBOX_WEAPON_SATCHEL      14
#define GEARBOX_WEAPON_SNARK        15
#define GEARBOX_WEAPON_GRAPPLE      16
#define GEARBOX_WEAPON_EAGLE        17
#define GEARBOX_WEAPON_PIPEWRENCH   18
#define GEARBOX_WEAPON_M249         19
#define GEARBOX_WEAPON_DISPLACER    20
#define GEARBOX_WEAPON_UNKNOWN      21
#define GEARBOX_WEAPON_SHOCKRIFLE   22
#define GEARBOX_WEAPON_SPORELAUNCHER 23
#define GEARBOX_WEAPON_SNIPERRIFLE  24
#define GEARBOX_WEAPON_KNIFE        25

#define SI_WEAPON_BRIEFCASE 1
#define SI_WEAPON_VOMIT 2
#define SI_WEAPON_357 3
#define SI_WEAPON_9MMAR 4
#define SI_WEAPON_CROSSBOW 6
#define SI_WEAPON_SHOTGUN 7
#define SI_WEAPON_RPG 8
#define SI_WEAPON_GAUSS 9
#define SI_WEAPON_HORNETGUN 11
#define SI_WEAPON_HANDGRENADE 12
#define SI_WEAPON_TRIPMINE 13
#define SI_WEAPON_SATCHEL 14
#define SI_WEAPON_TRANSISTOR 15
#define SI_WEAPON_GRAPPLE 21
#define SI_WEAPON_CLOAK 23

#define FLF_WEAPON_SAKO 9 //rifle
#define FLF_WEAPON_AK5 10 //assault rifle
#define FLF_WEAPON_RS202M2 11 //shotgun, 10 rounds
#define FLF_WEAPON_MP5SD 16  //smg
#define FLF_WEAPON_M4 17  //assult rifle, zoom
#define FLF_WEAPON_FLASHBANG 18
#define FLF_WEAPON_HEGRENADE 19
#define FLF_WEAPON_MP5A2 20 //smg
#define FLF_WEAPON_UMP45 21 //smg
#define FLF_WEAPON_SPAS12 22 //shotgun
#define FLF_WEAPON_BERETTA 23 //pistol
#define FLF_WEAPON_KNIFE 24
#define FLF_WEAPON_MAC10 25 //smg
#define FLF_WEAPON_MK23 26 //pistol
#define FLF_WEAPON_MSG90 27 //rifle
#define FLF_WEAPON_FAMAS 28 //assault rifle
#define FLF_WEAPON_HK21 29 //big gun

#define BOT_WEAPON_FIRED (1)
#define BOT_WEAPON_FIRING (2)
#define BOT_WEAPON_RELOADING (3)
#define BOT_WEAPON_CANT_SHOOT (4)

bool LoadWeaponData(void);
float GetBaseFitnessFromFile(int weapon_id);

class CBotMelee: public CBotWeapon
{
public:
	CBotMelee(bot_weapon_t, bot_ptr pBot);
	float Fitness(Vector target, float targetDistance, TargetType targetType);
	bool ShouldPickup(TF_BackPack * pack);
	bool NeedAmmo(void);
};

//#define TF_WEAPON_TRANQ         20
//#define TF_WEAPON_RAILGUN       21
class CBotPistol:public CBotWeapon
{
public:
	CBotPistol(bot_weapon_t, bot_ptr pBot);
	float Fitness(Vector target, float targetDistance, TargetType targetType);
	int Fire(Vector target);
	bool ShouldPickup(TF_BackPack * pack);
};

class CBotSMG:public CBotWeapon
{
public:
	CBotSMG(bot_weapon_t, bot_ptr pBot);
	float Fitness(Vector target, float targetDistance, TargetType targetType);
};

class CBotRifle:public CBotWeapon
{
public:
	CBotRifle(bot_weapon_t, bot_ptr pBot);
	float Fitness(Vector target, float targetDistance, TargetType targetType);
	Vector FuzzAiming(Vector aimVector);
	int Fire(Vector target);
	Vector GetTargetVector(Vector botOrigin, Vector targetOrigin, edict_t * pBotEnemy);
};

class CBotShotgun:public CBotWeapon
{
public:
	CBotShotgun(bot_weapon_t, bot_ptr pBot);
	float Fitness(Vector target, float targetDistance, TargetType targetType);
	bool ShouldPickup(TF_BackPack * pack);
};

class CBotAssault:public CBotWeapon
{
public:
	CBotAssault(bot_weapon_t, bot_ptr pBot);
	float Fitness(Vector target, float targetDistance, TargetType targetType);
};

class CBotHK21:public CBotWeapon
{
public:
	CBotHK21(bot_weapon_t, bot_ptr pBot);
	float Fitness(Vector target, float targetDistance, TargetType targetType);
	Vector GetBarrelOffset(void);
	int Fire(Vector target);
	float startTime;
	float stopTime;
};

class CBotGrenade:public CBotWeapon
{
public:
	CBotGrenade(bot_weapon_t, bot_ptr pBot);
	float Fitness(Vector target, float targetDistance, TargetType targetType);
	int Fire(Vector target);
};


//#define TF_WEAPON_SNIPERRIFLE    6
class CBotSniperRifle:public CBotWeapon
{
public:
	CBotSniperRifle(bot_weapon_t, bot_ptr pBot);
	float Fitness(Vector target, float targetDistance, TargetType targetType);
	int Fire(Vector target);
	float chargeTime;
	float reloadTime;
	Vector GetTargetVector(Vector botOrigin, Vector targetOrigin, edict_t * pBotEnemy);
	bool ShouldPickup(TF_BackPack * pack);
};

//#define TF_WEAPON_AUTORIFLE      7
class CBotAutoRifle:public CBotWeapon
{
public:
	CBotAutoRifle(bot_weapon_t, bot_ptr pBot);
	float Fitness(Vector target, float targetDistance, TargetType targetType);
	bool ShouldPickup(TF_BackPack * pack);
};

//#define TF_WEAPON_NAILGUN       10
//#define TF_WEAPON_SUPERNAILGUN  11
class CBotNailgun:public CBotWeapon
{
public:
	CBotNailgun(bot_weapon_t, bot_ptr pBot);
	float Fitness(Vector target, float targetDistance, TargetType targetType);
	bool ShouldPickup(TF_BackPack * pack);
};

//#define TF_WEAPON_GL            12
class CBotGLauncher: public CBotWeapon
{
public:
	CBotGLauncher(bot_weapon_t, bot_ptr pBot);
	float Fitness(Vector target, float targetDistance, TargetType targetType);
	Vector GetTargetVector(Vector botOrigin, Vector targetOrigin, edict_t * pBotEnemy);
	bool ShouldPickup(TF_BackPack * pack);
};

//#define TF_WEAPON_RPG           14
//#define TF_WEAPON_IC            15
class CBotRocket: public CBotWeapon
{
public:
	CBotRocket(bot_weapon_t, bot_ptr pBot);
	float Fitness(Vector target, float targetDistance, TargetType targetType);
	Vector GetTargetVector(Vector botOrigin, Vector targetOrigin, edict_t * pBotEnemy);
	bool ShouldPickup(TF_BackPack * pack);
};

//#define TF_WEAPON_FLAMETHROWER  13
class CBotFlameThrower:public CBotWeapon
{
public:
	CBotFlameThrower(bot_weapon_t, bot_ptr pBot);
	float Fitness(Vector target, float targetDistance, TargetType targetType);
	bool ShouldPickup(TF_BackPack * pack);
};

//#define TF_WEAPON_AC            17
class CBotAutoCannon: public CBotWeapon
{
public:
	CBotAutoCannon(bot_weapon_t, bot_ptr pBot);
	float Fitness(Vector target, float targetDistance, TargetType targetType);
	Vector GetBarrelOffset(void);
	bool ShouldPickup(TF_BackPack * pack);
};

/*class CBotFlashbang:public CBotGrenade
{
public:
	CBotFlashbang(bot_weapon_t);
};

class CBotFragGrenade: public CBotGrenade
{
public:
	CBotFragGrenade(bot_weapon_t);
};
*/


#endif // BOT_WEAPONS_H

